#include <cstdio>
#include <cstdlib>
#include <algorithm>

using namespace std;

const int MaxN = 20000;
const int MaxS = 50000;
const int INF = 0x3f3f3f3f;

int N, S;
int a[MaxN];
int largestMin[MaxS], sol[MaxS];

void ReadInput() {
    scanf("%d %d", &N, &S);
    for (int i = 0; i < N; i += 1) {
        scanf("%d", a + i);
    }
}

void SolveOk() {
    sort(a, a + N);
    int sum = 0;
    for (int i = 1; i <= S; i += 1) {
        sol[i] = INF;
        largestMin[i] = 0;
    }
    for (int index = 0; index < N; index += 1) {
        int curVal = a[index];
        sum += curVal;
        largestMin[0] = curVal;
        for (int k = min(sum, S); k >= curVal; k--) {
            if (largestMin[k - curVal] > largestMin[k]) {
                largestMin[k] = largestMin[k - curVal];
                if (curVal - largestMin[k] < sol[k]) {
                    sol[k] = curVal - largestMin[k];
                }
            }
        }
    }
    for (int i = 1; i <= S; i += 1) {
        if (sol[i] == INF) {
            sol[i] = -1;
        }
        printf("%d ", sol[i]);
    }
    printf("\n");
}

int main() {
    int tst;
	freopen("euro.in", "r", stdin);
	freopen("euro.out", "w", stdout);
    scanf("%d", &tst);
    while (tst--) {
        ReadInput();
        SolveOk();
    }
    return 0;
}
