#include <bits/stdc++.h>

using namespace std;

ifstream f("euro.in");
ofstream g("euro.out");

#define pb push_back
#define ll long long
#define mp make_pair

const int NMAX = 1005;
const int PMAX = 1005;
const int INF = (1 << 29);

int n, p, a[NMAX];
int dp[NMAX][PMAX];
int ans[PMAX];

int bagaDin(vector< int> &v, int minVal, int maxVal) {
	for (int i = 0; i <= v.size(); ++i) {
		for (int j = 0; j <= p; ++j) {
			dp[i][j] = 0;
		}
	}

	dp[0][0] = 1;
	for (int i = 1; i <= v.size(); ++i) {
		int currVal = v[i - 1];
		for (int j = 0; j <= p; ++j) {
			dp[i][j] = dp[i - 1][j];
			if (j - currVal >= 0) {
				dp[i][j] |= dp[i - 1][j - currVal];
			}
		}
	}
	for (int i = 1; i <= p; ++i) {
		if (dp[v.size()][i] != 0) {
			ans[i] = min(ans[i], maxVal - minVal);
		}
	}
}

int main() {
	int t;
	f >> t;
	for (; t; --t) {
		f >> n >> p;
		for (int i = 1; i <= n; ++i) {
			f >> a[i];
		}

		sort(a + 1, a + n + 1);

		for (int i = 1; i <= p; ++i) {
			ans[i] = INF;
		}

		for (int i = 1; i <= n; ++i) {
			vector< int> v;
			for (int j = i; j <= n; ++j) {
				v.pb(a[j]);
				bagaDin(v, a[i], a[j]);
			}
		}
		for (int i = 1; i <= p; ++i) {
			if (ans[i] == INF) {
				ans[i] = -1;
			}
			g << ans[i] << " ";
		}
		g << "\n";
	}

	return 0;
}
