// Daniel Posdarascu
// 40 de puncte

#include<stdio.h>
#include<string.h>
#include<unordered_map>
#include<vector>
using namespace std;

#define ll long long
#define NMAX 100005
#define pb push_back
#define INF 1000000005

unordered_map< ll, int > myHash;
int euler[2 * NMAX], sol[NMAX], n, m;
char viz[NMAX];
vector<int> v[NMAX];
int left[2 * NMAX], right[2 * NMAX], nrEuler;
int dfirst[NMAX], dlast[NMAX], entry[NMAX], last[NMAX];

inline void dfs(int nod, int lst)
{
	euler[++nrEuler] = nod;
	viz[nod] = 1;
	
	int i, lim = v[nod].size(), start = 0;
	if(lst)
	{
		for(i = 0; i < lim; i++)
			if(v[nod][i] == lst)
				break;
		if(i < lim - 1)
			start = i + 1;
		else
			start = 0;
	}
	for(i = start; i < lim; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}
	for(int i = 0; i < start; i++)
		if(!viz[v[nod][i]])
		{
			dfs(v[nod][i], nod);
			euler[++nrEuler] = nod;
		}
}

inline void read()
{
	int val, nr;
	
    scanf("%d%d",&n,&m);
    for(int i = 1; i <= n; i++)
    {
        scanf("%d",&nr);
        for(int j = 1; j <= nr; j++)
        {   
        	scanf("%d",&val);
        	v[i].pb(val);
        }
    }	
}

inline void prep()
{
	int nod1, nod2, timp;
	
    dfs(1, 0);
    
    for(int i = nrEuler + 1; i <= 2 * nrEuler - 1; i++)
    	euler[i] = euler[i - nrEuler + 1];
    
    for(int i = 1; i < nrEuler; i++)
		myHash[(ll)euler[i] * NMAX + euler[i + 1]] = i;
		
	for(int i = 1; i <= m; i++)
    {
    	memset(viz, 0, sizeof(viz));
    	scanf("%d%d%d",&nod1,&nod2,&timp);
   		int index = myHash[(ll)nod1 * NMAX + v[nod1][nod2 - 1]];
    	for(int j = index; j <= index + nrEuler; j++)
    		if(!viz[euler[j]])
    		{
    			sol[euler[j]] = max(sol[euler[j]], timp + j - index);
    			viz[euler[j]] = 1;
    		}
   	}
}

inline void write()
{
	for(int i = 1; i <= n; i++)
		printf("%d ", (sol[i] < 0 ? 0 : sol[i]));
	printf("\n");
}

int main ()
{
    freopen("sushi.in", "r", stdin);
    freopen("sushi.out", "w", stdout);

	read();
	prep();
	write();

	return 0;
}
