//”50 de puncte
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
using namespace std;

int q, line, col, a, b, mod;

int getPow(int n)
{
	int pw = 0;
	while (n) pw += n, n /= 2;
	return pw;
}

int getCombParity(int n, int k)
{
	if (k < 0 || n < 0 || n < k) return 0;
	int pwUp = getPow(n), pwDown = getPow(k) + getPow(n - k);
	if (pwUp > pwDown) return 0;
	return 1;
}

int main(int argc, char **argv)
{
	freopen(argv[1], "r", stdin);
	freopen(argv[2], "w", stdout);

	scanf("%i %i %i %i %i %i", &q, &line, &col, &a, &b, &mod);	

	for (int i = 1; i <= q; ++ i)
	{
		int ans = 0;
		for (int j = 0; j <= col; ++ j)
			ans ^= j * getCombParity(line + col - 1 - j, col - j);
		printf("%d\n", ans);
		line = (a * line + b) % mod;
		col = (a * col + b) % mod;
	}
	return 0;
}