#include<stdio.h>
#include<vector>
using namespace std;

#define pb push_back
#define pi pair<int, int>
#define x first
#define y second
#define NMAX 200005
#define ll long long

ll AIB[NMAX], sp[NMAX], sol[NMAX];
vector<int> queries[NMAX];
pi q[NMAX];
int last[NMAX], left, v[NMAX];
int n, m;

inline void update(int poz, int val)
{
	if(!poz)
		return ;
	for(; poz <= n; poz += ((poz ^ (poz - 1)) & poz))
        AIB[poz] += val;
}

inline ll query(int poz)
{
	ll s = 0;
    for(; poz; poz -= ((poz ^ (poz - 1)) & poz))
   	    s += AIB[poz];
    return s;
}


inline void read()
{
	scanf("%d%d",&n,&m);
	for(int i = 1; i <= n; i++)
		scanf("%d",&v[i]);
	for(int i = 1; i <= m; i++)
	{
		scanf("%d%d",&q[i].x,&q[i].y);
		queries[q[i].y].pb(i);
	}
}

inline int cmp(const pi& a, const pi& b)
{
	return a.y < b.y;
}

inline void solve()
{
	for(int i = 1; i <= n; i++)
	{
		left = last[v[i]];
		if(left)
			update(left, i - left);
		int lim = queries[i].size();
		for(int j = 0; j < lim; j++)
			sol[queries[i][j]] = query(i - 1) - query(q[queries[i][j]].x - 1);
		last[v[i]] = i;
	}
}

inline void write()
{
	for(int i = 1; i <= m; i++)
		printf("%lld\n", sol[i]);
}

int main ()
{
	freopen("calafat.in","r",stdin);
	freopen("calafat.out","w",stdout);
	
	read();
	solve();
	write();
	
	return 0;
}
