#include <cstdio>
#include <cstdlib>
#include <algorithm>
using namespace std;

const int nmax = 10010, pmax = 5010, inf = 0x3f3f3f3f;

int t, n, p, ans[pmax], dp[pmax], v[nmax];

int main()
{
	freopen("euro.in", "r", stdin);
	freopen("euro.out", "w", stdout);

	scanf("%i", &t);
	for (; t; -- t)
	{
		scanf("%i %i", &n, &p);
		for (int i = 1; i <= n; ++ i)
			scanf("%i", &v[i]);

		sort(v + 1, v + n + 1);

		for (int i = 1; i <= p; ++ i)
			ans[i] = inf;

		for (int i = 1; i <= n; ++ i)
		{
			for (int j = 0; j < pmax; ++ j)
				dp[j] = inf;
			dp[0] = 1;

			for (int j = i; j <= n; ++ j)
				for (int k = pmax - 1; k >= v[j]; -- k)
					if (dp[k - v[j]] != inf)
					{
						if (dp[k] == inf)
							ans[k] = min(ans[k], v[j] - v[i]);
						dp[k] = 1;
					}
		}

		for (int i = 1; i <= p; ++ i)
		{
			if (ans[i] == inf)
				ans[i] = -1;
			printf("%i ", ans[i]);
		}
		printf("\n");
	}

	return 0;
}