#include <cstdio>
#include <algorithm>
#define MAXN 4005
#define MAXP 8005
using namespace std;

int nrt;
int n, p, v[MAXN];
int mnCan[MAXP];
int sol[MAXP];

int main() {
    freopen("euro.in", "r", stdin);
    freopen("euro.out", "w", stdout);

    scanf("%d", &nrt);

    while(nrt--) {
        scanf("%d %d", &n, &p);

        for(int i = 1; i <= n; ++i)
            scanf("%d", &v[i]);

        for(int i = 1; i <= p; ++i) {
            sol[i] = p + 1;
            mnCan[i] = -1;
        }

        sort(v + 1, v + n + 1);
        for(int i = 1; i <= n; ++i) {
            for(int j = p; j > v[i]; --j)
                mnCan[j] = max(mnCan[j], mnCan[j - v[i]]);
            mnCan[v[i]] = v[i];

            for(int j = 0; j <= p; ++j)
                if(mnCan[j] > -1)
                    sol[j] = min(sol[j], v[i] - mnCan[j]);
        }

        for(int i = 1; i <= p; ++i)
            printf("%d ", (sol[i] == p + 1)?(-1):sol[i]);
        printf("\n");
    }

    return 0;
}
