//20 de puncte
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cassert>
using namespace std;

const int nmax = 1010;

int q, line, col, a, b, mod;
int mat[nmax][nmax];

int main(int argc, char **argv)
{
	freopen(argv[1], "r", stdin);
	freopen(argv[2], "w", stdout);	

	scanf("%i %i %i %i %i %i", &q, &line, &col, &a, &b, &mod);

	assert(1 <= q && q <= 100000);
	assert(1 <= mod && mod <= 1000);
	assert(0 <= line && line < mod);
	assert(0 <= col && col < mod);
	assert(1 <= a && a <= 9);
	assert(1 <= b && b <= 9);

	for (int i = 0; i < mod; ++ i)
		mat[0][i] = i;
	for (int i = 1; i < mod; ++ i)
		for (int j = 0; j < mod; ++ j)
		{
			if (j > 0) mat[i][j] = mat[i][j - 1];
			mat[i][j] ^= mat[i - 1][j];
		}

	for (int i = 1; i <= q; ++ i)
	{
		printf("%d\n", mat[line][col]);
		line = (a * line + b) % mod;
		col = (a * col + b) % mod;
	}

	return 0;
}