#include <bits/stdc++.h>

using namespace std;

ifstream f("arbore.in");
ofstream g("arbore.out");

#define pb push_back
#define ll long long
#define mp make_pair

const int nmax = 100005;
const int mod = 1e9 + 7;
const int RAMANE = 0;
const int ILSCOT = 1;

int viz[nmax], dp[nmax][3], cnt[nmax][3];
vector<int> gf[nmax];
int t[nmax];
int n;

void update(int &x) {
	if (x >= mod) {
		x -= mod;
	}
}

void dfs(int node) {
	viz[node] = 1;
	int nrFii = 0;
	for (int i = 0; i < gf[node].size(); ++i) {
		int vc = gf[node][i];
		if (viz[vc] == 0) {
			++nrFii;
			t[vc] = node;
			dfs(vc);
		}
	}

	if (nrFii == 0) {
		// e frunza;
		dp[node][RAMANE] = 1;
		cnt[node][RAMANE] = 1;
		dp[node][ILSCOT] = 0;
		cnt[node][ILSCOT] = 1;
		return;
	}

	int maxComp = 1;
	cnt[node][ILSCOT] = 1;
	cnt[node][RAMANE] = 1;
	for (int i = 0; i < gf[node].size(); ++i) {
		int vc = gf[node][i];
		if (t[node] != vc) {
			maxComp += max(dp[vc][RAMANE] - 1, dp[vc][ILSCOT]);
			dp[node][ILSCOT] += max(dp[vc][RAMANE], dp[vc][ILSCOT]);
			update(maxComp);

			int ce[2];

			if (dp[vc][RAMANE] == dp[vc][ILSCOT]) {
				ce[ILSCOT] = (cnt[vc][RAMANE] + cnt[vc][ILSCOT]) % mod;
			} else {
				if (dp[vc][RAMANE] > dp[vc][ILSCOT]) {
					ce[ILSCOT] = cnt[vc][RAMANE];
				} else {
					ce[ILSCOT] = cnt[vc][ILSCOT];
				}
			}

			if (dp[vc][RAMANE] - 1 == dp[vc][ILSCOT]) {
				ce[RAMANE] = (cnt[vc][RAMANE] + cnt[vc][ILSCOT]) % mod;
			} else {
				if (dp[vc][RAMANE] - 1 > dp[vc][ILSCOT]) {
					ce[RAMANE] = cnt[vc][RAMANE];
				} else {
					ce[RAMANE] = cnt[vc][ILSCOT];
				}
			}

			cnt[node][ILSCOT] = (1LL * cnt[node][ILSCOT] * ce[ILSCOT]) % mod;
			cnt[node][RAMANE] = (1LL * cnt[node][RAMANE] * ce[RAMANE]) % mod;
		}
	}
	dp[node][RAMANE] = maxComp;

}

int main() {
	f >> n;
	for (int i = 2; i <= n; ++i) {
		int x, y;
		f >> x >> y;
		gf[x].pb(y);
		gf[y].pb(x);
	}

	dfs(1);
	int node = 1;
	g << max(dp[node][RAMANE], dp[node][ILSCOT]) << "\n";
	if (dp[node][RAMANE] == dp[node][ILSCOT]) {
		g << (cnt[node][RAMANE] + cnt[node][ILSCOT]) % mod << "\n";
	} else {
		if (dp[node][RAMANE] > dp[node][ILSCOT]) {
			g << cnt[node][RAMANE] << "\n";
		} else {
			g << cnt[node][ILSCOT] << "\n";
		}
	}

	return 0;
}